/* (C) 2016 Hot-World GmbH & Co. KG <rlittwin@repetier.com>
 All Rights Reserved

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 It is allowed to use this code to create or use in products connecting to
 Repetier-Server or to use it for own plugins/modules with Repetier-Server.
 This includes free and commercial products.
 Usage for other products is strictly forbidden.
 */
var core_1 = require('@angular/core');
var modal_service_1 = require("./modal.service");
var modal_view_component_1 = require("./modal-view.component");
var modal_head_component_1 = require("./modal-head.component");
var modal_content_component_1 = require("./modal-content.component");
var modal_footer_component_1 = require("./modal-footer.component");
var integer_keyboard_component_1 = require("../integer-keyboard.component");
var RSIntKeyboardModal = (function () {
    function RSIntKeyboardModal(modal) {
        this.modal = modal;
        this.value = "";
        this.valueShow = "";
        this.head = "";
        this.error = "&nbsp;";
        this.canSend = true;
        this.page = 0; // 0 = a-z, 1 = A-Z, 2 = numbers/symbols
        this.options = {};
        this.hasError = false;
        this.options = this.modal.data;
        this.value = this.modal.data.defaultValue;
        this.head = this.modal.data.head;
        this.update(this.value);
    }
    RSIntKeyboardModal.prototype.update = function (newVal) {
        this.hasError = false;
        this.value = newVal;
        if (newVal.length == 0) {
            this.canSend = false;
        }
        else {
            var intVal = parseInt(newVal);
            if (this.options.min && intVal < this.options.min) {
                this.hasError = true;
                this.error = "<?php _('Min. value is @!') ?>".replace("@", this.options.min);
            }
            if (this.options.max && intVal > this.options.max) {
                this.hasError = true;
                this.error = "<?php _('Max. value is @!') ?>".replace("@", this.options.max);
            }
            this.canSend = !this.hasError;
        }
        this.valueShow = this.value.split(" ").join("&nbsp;");
        if (this.valueShow.length == 0)
            this.valueShow = "&nbsp;";
        if (!this.hasError)
            this.error = "&nbsp;";
    };
    RSIntKeyboardModal.prototype.send = function () {
        if (this.hasError === false)
            this.modal.close(parseInt(this.value));
    };
    RSIntKeyboardModal = __decorate([
        core_1.Component({
            selector: 'rs-int-keyboard-modal',
            template: "<div class=\"rs-string-keyboard-modal\">\n    <rs-modal-head style=\"max-width:160px\"><h1 [innerHTML]=\"head\"><div class=\"close\" (click)=\"modal.cancel()\"><i class=\"fa fa-close\"></i></div></h1></rs-modal-head>\n    <rs-modal-content>\n        <div style=\"padding:2px 5px\">\n            <div class=\"input\"><span [innerHTML]=\"valueShow\"></span></div>\n        </div>\n        <div class=\"error\" [innerHTML]=\"error\"></div>\n        <rs-integer-keyboard (send)=\"send()\" [value]=\"value\" (valueChange)=\"update($event)\" [canSend]=\"canSend\"></rs-integer-keyboard>\n    </rs-modal-content>\n</div>",
            host: {
                class: ''
            },
            directives: [modal_content_component_1.RSModelContentComponent, modal_footer_component_1.RSModelFooterComponent, modal_head_component_1.RSModalHeadComponent, integer_keyboard_component_1.RSIntegerKeyboardComponent],
            providers: []
        }), 
        __metadata('design:paramtypes', [modal_view_component_1.RSModalViewComponent])
    ], RSIntKeyboardModal);
    return RSIntKeyboardModal;
})();
var RSIntKeyboard = (function () {
    function RSIntKeyboard(modal) {
        this.modal = modal;
    }
    RSIntKeyboard.prototype.getInt = function (oldValue, head, options) {
        if (!options)
            options = {};
        options.defaultValue = "" + oldValue;
        options.head = head;
        options.modalClass = "modal-noborder";
        return this.modal.show(RSIntKeyboardModal, options);
    };
    RSIntKeyboard = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [modal_service_1.RSModal])
    ], RSIntKeyboard);
    return RSIntKeyboard;
})();
exports.RSIntKeyboard = RSIntKeyboard;
//# sourceMappingURL=int-keyboard.service.js.map
