/* (C) 2016 Hot-World GmbH & Co. KG <rlittwin@repetier.com>
 All Rights Reserved

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 It is allowed to use this code to create or use in products connecting to
 Repetier-Server or to use it for own plugins/modules with Repetier-Server.
 This includes free and commercial products.
 Usage for other products is strictly forbidden.
 */
var core_1 = require('@angular/core');
var RSBinding_1 = require("../../RSBinding");
var confirm_modal_service_1 = require("./confirm-modal.service");
var modal_view_component_1 = require("./modal-view.component");
var RSUtils_1 = require("../../RSBinding/RSUtils");
var RSModal = (function () {
    function RSModal(compiler) {
        this.compiler = compiler;
        this.component = undefined; // last created component
    }
    RSModal.prototype.show = function (compType, data, modalType) {
        var _this = this;
        var deferred = new RSBinding_1.Deferred();
        if (!data)
            data = {};
        if (typeof (data.closeable) === 'undefined')
            data.closeable = true;
        if (!modalType) {
            modalType = modal_view_component_1.RSModalViewComponent;
        }
        this.compiler.resolveComponent(modalType).then(function (factory) {
            return RSModal.defaultView.createComponent(factory, 0, RSModal.defaultView.injector);
        }).then(function (comp) {
            //console.log("comp");console.log(comp);
            _this.component = comp;
            _this.component.instance.component = comp;
            _this.component.instance.deferred = deferred;
            _this.component.instance.data = data;
            _this.component.instance.componentType = compType;
            _this.component.instance.starter = _this;
            if (data.modalClass)
                _this.component.instance.modalClass = data.modalClass;
            if (data.componentCreatedCallback) {
                data.componentCreatedCallback(comp);
            }
        });
        return deferred.promise;
    };
    /*close(reason:any) {
        if (!this.component)
            return;
        (<RSModal>this.component.instance).close(reason);
    }

    cancel() {
        if (!this.component)
            return;
        (<RSModal>this.component.instance).cancel();
    }*/
    RSModal.prototype.confirm = function (head, question, options) {
        if (!options)
            options = {};
        return this.show(confirm_modal_service_1.RSConfirmModal, RSUtils_1.RSUtils.extend({ head: head, question: question }, options), modal_view_component_1.RSModalViewComponent);
    };
    RSModal = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [core_1.ComponentResolver])
    ], RSModal);
    return RSModal;
})();
exports.RSModal = RSModal;
//# sourceMappingURL=modal.service.js.map
