/* (C) 2016 Hot-World GmbH & Co. KG <rlittwin@repetier.com>
 All Rights Reserved

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 It is allowed to use this code to create or use in products connecting to
 Repetier-Server or to use it for own plugins/modules with Repetier-Server.
 This includes free and commercial products.
 Usage for other products is strictly forbidden.
 */
var core_1 = require('@angular/core');
var modal_service_1 = require("./modal.service");
var modal_view_component_1 = require("./modal-view.component");
var modal_head_component_1 = require("./modal-head.component");
var modal_content_component_1 = require("./modal-content.component");
var modal_footer_component_1 = require("./modal-footer.component");
var RSStringKeyboardModal = (function () {
    function RSStringKeyboardModal(modal) {
        this.modal = modal;
        this.value = "";
        this.valueShow = "";
        this.head = "";
        this.error = "&nbsp;";
        this.page = 0; // 0 = a-z, 1 = A-Z, 2 = numbers/symbols
        this.options = {};
        this.hasError = false;
        console.log("RSStringKeyboardModal constructor");
        this.options = this.modal.data;
        this.value = this.modal.data.defaultValue;
        this.head = this.modal.data.head;
        this.update();
    }
    RSStringKeyboardModal.prototype.ngOnInit = function () {
        console.log("init " + this.modal.data.defaultValue);
    };
    RSStringKeyboardModal.prototype.update = function () {
        this.valueShow = this.value.split(" ").join("&nbsp;");
        if (this.valueShow.length == 0)
            this.valueShow = "&nbsp;";
        this.error = "&nbsp;";
        this.hasError = false;
        if (this.options.minLength && this.value.length < this.options.minLength) {
            this.hasError = true;
            this.error = "<?php _('Min. length is @ chars!') ?>".replace("@", this.options.minLength);
        }
        if (this.options.maxLength && this.value.length > this.options.maxLength) {
            this.hasError = true;
            this.error = "<?php _('Max. length is @ chars!') ?>".replace("@", this.options.maxLength);
        }
    };
    RSStringKeyboardModal.prototype.key = function (k) {
        this.value += k;
        this.update();
    };
    RSStringKeyboardModal.prototype.del = function () {
        if (this.value.length > 0)
            this.value = this.value.substr(0, this.value.length - 1);
        this.update();
    };
    RSStringKeyboardModal.prototype.send = function () {
        if (this.hasError === false)
            this.modal.close(this.value);
    };
    RSStringKeyboardModal = __decorate([
        core_1.Component({
            selector: 'rs-string-keyboard-modal',
            template: "<div class=\"rs-string-keyboard-modal\">\n    <rs-modal-head><h1>{{head}}<div class=\"close\" (click)=\"modal.cancel()\"><i class=\"fa fa-close\"></i></div></h1></rs-modal-head>\n    <rs-modal-content>\n        <div style=\"padding:2px 5px\">\n            <div class=\"input\"><span [innerHTML]=\"valueShow\"></span></div>\n        </div>\n        <div class=\"error\" [innerHTML]=\"error\"></div>\n\n        <div *ngIf=\"page==0\">\n            <div class=\"keyboard-string\">\n                <div class=\"keyboard\">\n                    <div (click)=\"key('q')\" class=\"key key-2\">\n                        <div>q</div>\n                    </div>\n                    <div (click)=\"key('w')\" class=\"key key-2\">\n                        <div>w</div>\n                    </div>\n                    <div (click)=\"key('e')\" class=\"key key-2\">\n                        <div>e</div>\n                    </div>\n                    <div (click)=\"key('r')\" class=\"key key-2\">\n                        <div>r</div>\n                    </div>\n                    <div (click)=\"key('t')\" class=\"key key-2\">\n                        <div>t</div>\n                    </div>\n                    <div (click)=\"key('y')\" class=\"key key-2\">\n                        <div>y</div>\n                    </div>\n                    <div (click)=\"key('u')\" class=\"key key-2\">\n                        <div>u</div>\n                    </div>\n                    <div (click)=\"key('i')\" class=\"key key-2\">\n                        <div>i</div>\n                    </div>\n                    <div (click)=\"key('o')\" class=\"key key-2\">\n                        <div>o</div>\n                    </div>\n                    <div (click)=\"key('p')\" class=\"key key-2\">\n                        <div>p</div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div class=\"key-1\"></div>\n                    <div (click)=\"key('a')\" class=\"key key-2\">\n                        <div>a</div>\n                    </div>\n                    <div (click)=\"key('s')\" class=\"key key-2\">\n                        <div>s</div>\n                    </div>\n                    <div (click)=\"key('d')\" class=\"key key-2\">\n                        <div>d</div>\n                    </div>\n                    <div (click)=\"key('f')\" class=\"key key-2\">\n                        <div>f</div>\n                    </div>\n                    <div (click)=\"key('g')\" class=\"key key-2\">\n                        <div>g</div>\n                    </div>\n                    <div (click)=\"key('h')\" class=\"key key-2\">\n                        <div>h</div>\n                    </div>\n                    <div (click)=\"key('j')\" class=\"key key-2\">\n                        <div>j</div>\n                    </div>\n                    <div (click)=\"key('k')\" class=\"key key-2\">\n                        <div>k</div>\n                    </div>\n                    <div (click)=\"key('l')\" class=\"key key-2\">\n                        <div>l</div>\n                    </div>\n                    <div class=\"key-1\"></div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"page=1\" class=\"key key-2\">\n                        <div class=\"rs rs-shift\"></div>\n                    </div>\n                    <div (click)=\"key('z')\" class=\"key key-2\">\n                        <div>z</div>\n                    </div>\n                    <div (click)=\"key('x')\" class=\"key key-2\">\n                        <div>x</div>\n                    </div>\n                    <div (click)=\"key('c')\" class=\"key key-2\">\n                        <div>c</div>\n                    </div>\n                    <div (click)=\"key('v')\" class=\"key key-2\">\n                        <div>v</div>\n                    </div>\n                    <div (click)=\"key('b')\" class=\"key key-2\">\n                        <div>b</div>\n                    </div>\n                    <div (click)=\"key('n')\" class=\"key key-2\">\n                        <div>n</div>\n                    </div>\n                    <div (click)=\"key('m')\" class=\"key key-2\">\n                        <div>m</div>\n                    </div>\n                    <div (click)=\"key('@')\" class=\"key key-2\">\n                        <div>@</div>\n                    </div>\n                    <div (click)=\"del()\" class=\"key key-2\">\n                        <div class=\"rs rs-backspace\"></div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"page=2\" class=\"key key-4 special\">\n                        <div>Num</div>\n                    </div>\n                    <div (click)=\"key(' ')\" class=\"key key-8 special\">\n                        <div>Space</div>\n                    </div>\n                    <div (click)=\"send()\" class=\"key key-6\" [attr.disabled]=\"hasError\">\n                        <div class=\"fa fa-level-down fa-rotate-90\"></div>\n                    </div>\n                </div>\n            </div>\n        </div>\n        <div *ngIf=\"page==1\">\n            <div class=\"keyboard-string\">\n                <div class=\"keyboard\">\n                    <div (click)=\"key('Q')\" class=\"key key-2\">\n                        <div>Q</div>\n                    </div>\n                    <div (click)=\"key('W')\" class=\"key key-2\">\n                        <div>W</div>\n                    </div>\n                    <div (click)=\"key('E')\" class=\"key key-2\">\n                        <div>E</div>\n                    </div>\n                    <div (click)=\"key('R')\" class=\"key key-2\">\n                        <div>R</div>\n                    </div>\n                    <div (click)=\"key('T')\" class=\"key key-2\">\n                        <div>T</div>\n                    </div>\n                    <div (click)=\"key('Y')\" class=\"key key-2\">\n                        <div>Y</div>\n                    </div>\n                    <div (click)=\"key('U')\" class=\"key key-2\">\n                        <div>U</div>\n                    </div>\n                    <div (click)=\"key('I')\" class=\"key key-2\">\n                        <div>I</div>\n                    </div>\n                    <div (click)=\"key('O')\" class=\"key key-2\">\n                        <div>O</div>\n                    </div>\n                    <div (click)=\"key('P')\" class=\"key key-2\">\n                        <div>P</div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div class=\"key-1\"></div>\n                    <div (click)=\"key('A')\" class=\"key key-2\">\n                        <div>A</div>\n                    </div>\n                    <div (click)=\"key('S')\" class=\"key key-2\">\n                        <div>S</div>\n                    </div>\n                    <div (click)=\"key('D')\" class=\"key key-2\">\n                        <div>D</div>\n                    </div>\n                    <div (click)=\"key('F')\" class=\"key key-2\">\n                        <div>F</div>\n                    </div>\n                    <div (click)=\"key('G')\" class=\"key key-2\">\n                        <div>G</div>\n                    </div>\n                    <div (click)=\"key('H')\" class=\"key key-2\">\n                        <div>H</div>\n                    </div>\n                    <div (click)=\"key('J')\" class=\"key key-2\">\n                        <div>J</div>\n                    </div>\n                    <div (click)=\"key('K')\" class=\"key key-2\">\n                        <div>K</div>\n                    </div>\n                    <div (click)=\"key('L')\" class=\"key key-2\">\n                        <div>L</div>\n                    </div>\n                    <div class=\"key-1\"></div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"page=0\" class=\"key key-2\">\n                        <div class=\"rs rs-shift\" style=\"font-size:70%\"></div>\n                    </div>\n                    <div (click)=\"key('Z')\" class=\"key key-2\">\n                        <div>Z</div>\n                    </div>\n                    <div (click)=\"key('X')\" class=\"key key-2\">\n                        <div>X</div>\n                    </div>\n                    <div (click)=\"key('C')\" class=\"key key-2\">\n                        <div>C</div>\n                    </div>\n                    <div (click)=\"key('V')\" class=\"key key-2\">\n                        <div>V</div>\n                    </div>\n                    <div (click)=\"key('B')\" class=\"key key-2\">\n                        <div>B</div>\n                    </div>\n                    <div (click)=\"key('N')\" class=\"key key-2\">\n                        <div>N</div>\n                    </div>\n                    <div (click)=\"key('M')\" class=\"key key-2\">\n                        <div>M</div>\n                    </div>\n                    <div (click)=\"key('@')\" class=\"key key-2\">\n                        <div>@</div>\n                    </div>\n                    <div (click)=\"del()\" class=\"key key-2\">\n                        <div class=\"rs rs-backspace\"></div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"page=2\" class=\"key key-4 special\">\n                        <div>Num</div>\n                    </div>\n                    <div (click)=\"key(' ')\" class=\"key key-8 special\">\n                        <div>Space</div>\n                    </div>\n                    <div (click)=\"send()\" class=\"key key-6\">\n                        <div class=\"fa fa-level-down fa-rotate-90\"></div>\n                    </div>\n                </div>\n            </div>\n        </div>\n        <div *ngIf=\"page==2\">\n            <div class=\"keyboard-string\">\n                <div class=\"keyboard\">\n                    <div (click)=\"key('[')\" class=\"key key-2\">\n                        <div>[</div>\n                    </div>\n                    <div (click)=\"key('(')\" class=\"key key-2\">\n                        <div>(</div>\n                    </div>\n                    <div (click)=\"key(')')\" class=\"key key-2\">\n                        <div>)</div>\n                    </div>\n                    <div (click)=\"key(']')\" class=\"key key-2\">\n                        <div>]</div>\n                    </div>\n                    <div (click)=\"key('{')\" class=\"key key-2\">\n                        <div>{</div>\n                    </div>\n                    <div (click)=\"key('}')\" class=\"key key-2\">\n                        <div>}</div>\n                    </div>\n                    <div class=\"key-1\"></div>\n                    <div (click)=\"key('7')\" class=\"key key-2\">\n                        <div>7</div>\n                    </div>\n                    <div (click)=\"key('8')\" class=\"key key-2\">\n                        <div>8</div>\n                    </div>\n                    <div (click)=\"key('9')\" class=\"key key-2\">\n                        <div>9</div>\n                    </div>\n                    <div (click)=\"del()\" class=\"key key-2\">\n                        <div class=\"rs rs-backspace\"></div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"key('/')\" class=\"key key-2\">\n                        <div>/</div>\n                    </div>\n                    <div (click)=\"key('*')\" class=\"key key-2\">\n                        <div>*</div>\n                    </div>\n                    <div (click)=\"key('\\\\')\" class=\"key key-2\">\n                        <div>\\</div>\n                    </div>\n                    <div (click)=\"key('_')\" class=\"key key-2\">\n                        <div>_</div>\n                    </div>\n                    <div (click)=\"key('#')\" class=\"key key-2\">\n                        <div>#</div>\n                    </div>\n                    <div (click)=\"key('?')\" class=\"key key-2\">\n                        <div>?</div>\n                    </div>\n                    <div class=\"key-1\"></div>\n                    <div (click)=\"key('4')\" class=\"key key-2\">\n                        <div>4</div>\n                    </div>\n                    <div (click)=\"key('5')\" class=\"key key-2\">\n                        <div>5</div>\n                    </div>\n                    <div (click)=\"key('6')\" class=\"key key-2\">\n                        <div>6</div>\n                    </div>\n                    <div (click)=\"key('+')\" class=\"key key-2\">\n                        <div>+</div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"key('$')\" class=\"key key-2\">\n                        <div>$</div>\n                    </div>\n                    <div (click)=\"key(',')\" class=\"key key-2\">\n                        <div>,</div>\n                    </div>\n                    <div (click)=\"key(';')\" class=\"key key-2\">\n                        <div>;</div>\n                    </div>\n                    <div (click)=\"key(':')\" class=\"key key-2\">\n                        <div>:</div>\n                    </div>\n                    <div (click)=\"key('%')\" class=\"key key-2\">\n                        <div>%</div>\n                    </div>\n                    <div (click)=\"key('&')\" class=\"key key-2\">\n                        <div>&amp;</div>\n                    </div>\n                    <div class=\"key-1\"></div>\n                    <div (click)=\"key('1')\" class=\"key key-2\">\n                        <div>1</div>\n                    </div>\n                    <div (click)=\"key('2')\" class=\"key key-2\">\n                        <div>2</div>\n                    </div>\n                    <div (click)=\"key('3')\" class=\"key key-2\">\n                        <div>3</div>\n                    </div>\n                    <div (click)=\"key('-')\" class=\"key key-2\">\n                        <div>-</div>\n                    </div>\n                </div>\n                <div class=\"keyboard\">\n                    <div (click)=\"page=0\" class=\"key key-4 special\">\n                        <div>ABC</div>\n                    </div>\n                    <div (click)=\"key('=')\" class=\"key key-2\">\n                        <div>=</div>\n                    </div>\n                    <div (click)=\"key('%')\" class=\"key key-2\">\n                        <div>%</div>\n                    </div>\n                    <div (click)=\"key('&quot;')\" class=\"key key-2\">\n                        <div>&quot;</div>\n                    </div>\n                    <div (click)=\"key('!')\" class=\"key key-2\">\n                        <div>!</div>\n                    </div>\n                    <div class=\"key-1\"></div>\n                    <div (click)=\"key('0')\" class=\"key key-2\">\n                        <div>0</div>\n                    </div>\n                    <div (click)=\"key('.')\" class=\"key key-2\">\n                        <div>.</div>\n                    </div>\n                    <div (click)=\"send()\" class=\"key key-4\">\n                        <div class=\"fa fa-level-down fa-rotate-90\"></div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </rs-modal-content>\n</div>",
            host: {
                class: ''
            },
            directives: [modal_content_component_1.RSModelContentComponent, modal_footer_component_1.RSModelFooterComponent, modal_head_component_1.RSModalHeadComponent],
            providers: []
        }), 
        __metadata('design:paramtypes', [modal_view_component_1.RSModalViewComponent])
    ], RSStringKeyboardModal);
    return RSStringKeyboardModal;
})();
var RSStringKeyboard = (function () {
    function RSStringKeyboard(modal) {
        this.modal = modal;
    }
    RSStringKeyboard.prototype.getString = function (oldValue, head, options) {
        if (!options)
            options = {};
        options.defaultValue = oldValue;
        options.head = head;
        options.modalClass = "modal-noborder";
        return this.modal.show(RSStringKeyboardModal, options);
    };
    RSStringKeyboard = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [modal_service_1.RSModal])
    ], RSStringKeyboard);
    return RSStringKeyboard;
})();
exports.RSStringKeyboard = RSStringKeyboard;
//# sourceMappingURL=string-keyboard.service.js.map
