/**
 * Created by littwin on 10.06.16.
 */
var core_1 = require("@angular/core");
var RepetierServer_1 = require("../../RSBinding/RepetierServer");
var modal_service_1 = require("./modal.service");
var modal_head_component_1 = require("./modal-head.component");
var modal_content_component_1 = require("./modal-content.component");
var modal_footer_component_1 = require("./modal-footer.component");
var modal_view_component_1 = require("./modal-view.component");
var button_component_1 = require("../button.component");
var RepetierServer_2 = require("../../RSBinding/RepetierServer");
var PrinterError_1 = require("../../RSBinding/PrinterError");
var VisualAidModal = (function () {
    function VisualAidModal(modal) {
        this.modal = modal;
        this.options = {};
        this.hasError = false;
        console.log("VisModal");
        this.options = this.modal.data;
    }
    VisualAidModal = __decorate([
        core_1.Component({
            selector: 'visual-aid-modal',
            template: "<div class=\"busy-modal\">Mod<h1 [innerHTML]=\"options.message\"></h1></div>",
            host: {
                class: ''
            },
            directives: [modal_content_component_1.RSModelContentComponent, modal_footer_component_1.RSModelFooterComponent, modal_head_component_1.RSModalHeadComponent],
            providers: []
        }), 
        __metadata('design:paramtypes', [modal_view_component_1.RSModalViewComponent])
    ], VisualAidModal);
    return VisualAidModal;
})();
var VisualAidErrorsModal = (function () {
    function VisualAidErrorsModal(modal, server) {
        this.modal = modal;
        this.server = server;
        this.options = {};
        this.options = this.modal.data;
    }
    VisualAidErrorsModal.prototype.ok = function () {
        PrinterError_1.PrinterError.markAllSeen(this.server.printerErrors);
    };
    VisualAidErrorsModal = __decorate([
        core_1.Component({
            selector: 'visual-aid-errors-modal',
            template: "<rs-modal-head><?php _('Printer Errors') ?></rs-modal-head>\n    <rs-modal-content>\n        <div *ngFor=\"let s of options.printerErrors\">\n            <h3>{{s.printer.name}}</h3>\n            <p>{{s.device}}: {{s.stateString}}</p>\n        </div>\n    </rs-modal-content>\n    <rs-modal-footer><rs-button (hit)=\"ok()\" class=\"error select full\"><?php _('OK') ?></rs-button></rs-modal-footer>",
            host: {
                class: ''
            },
            directives: [modal_content_component_1.RSModelContentComponent, modal_footer_component_1.RSModelFooterComponent, modal_head_component_1.RSModalHeadComponent, button_component_1.RSButtonComponent],
            providers: []
        }), 
        __metadata('design:paramtypes', [modal_view_component_1.RSModalViewComponent, RepetierServer_2.RepetierServer])
    ], VisualAidErrorsModal);
    return VisualAidErrorsModal;
})();
var RSUIVisualAids = (function (_super) {
    __extends(RSUIVisualAids, _super);
    function RSUIVisualAids(modal, server) {
        var _this = this;
        _super.call(this);
        this.modal = modal;
        this.server = server;
        this.busyCounter = 0;
        this.disconnectedOn = false;
        this.busyMsg = [];
        this.comp = undefined;
        this.compCreated = function (c) {
            console.log("compCreated");
            _this.comp = c;
        };
        this.options = {
            modalClass: "modal-noborder",
            closeable: false,
            componentCreatedCallback: this.compCreated
        };
        this.compErrors = undefined;
        this.compErrorsCreated = function (c) {
            _this.compErrors = c;
        };
        this.errorOptions = {
            modalClass: "modal-error",
            componentCreatedCallback: this.compErrorsCreated,
            closeable: false,
            printerErrors: []
        };
    }
    RSUIVisualAids.prototype.onConnected = function () {
        console.log("con " + this.disconnectedOn);
        if (this.disconnectedOn) {
            this.disconnectedOn = false;
            this.hideBusy();
        }
    };
    RSUIVisualAids.prototype.onDisconnected = function () {
        console.log("dis " + this.disconnectedOn);
        if (!this.disconnectedOn) {
            this.disconnectedOn = true;
            this.showBusy("<?php _('Oops! I lost my connection to the server. Trying to reconnect.') ?>");
        }
    };
    RSUIVisualAids.prototype.showBusy = function (reason) {
        this.busyMsg.push(reason);
        this.options.message = reason;
        console.log("busy " + reason);
        if (this.busyMsg.length == 1) {
            this.modal.show(VisualAidModal, this.options).then(function () { }, function () { });
        }
    };
    RSUIVisualAids.prototype.hideBusy = function () {
        if (this.busyMsg.length == 0)
            return;
        this.busyMsg.pop();
        if (this.busyMsg.length == 0) {
            if (this.comp)
                this.comp.instance.cancel();
            this.comp = undefined;
        }
        else {
            this.options.message = this.busyMsg[this.busyMsg.length - 1];
        }
    };
    RSUIVisualAids.prototype.onPrinterError = function () {
        this.errorOptions.printerErrors = PrinterError_1.PrinterError.listErrors(this.server.printerErrors);
        if (!this.compErrors)
            this.modal.show(VisualAidErrorsModal, this.errorOptions).then(function () { }, function () { });
    };
    RSUIVisualAids.prototype.onPrinterErrorSolved = function () {
        if (this.compErrors)
            this.compErrors.instance.cancel();
        this.compErrors = undefined;
    };
    RSUIVisualAids = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [modal_service_1.RSModal, RepetierServer_2.RepetierServer])
    ], RSUIVisualAids);
    return RSUIVisualAids;
})(RepetierServer_1.VisualAids);
exports.RSUIVisualAids = RSUIVisualAids;
//# sourceMappingURL=ui-visual-aids.service.js.map
