import {Component} from '@angular/core';
import {DashboardComponent} from 'pages';

@Component({
    selector: "my-dashboard",
    template: `
<rs-page>
<rs-side>
    <rs-sideicon title="<?php _('Home') ?>" icon="fa fa-home" link="/"></rs-sideicon>
</rs-side><rs-side *rsIfConnected="true">
    <rs-sideicon *rsIfPrinting="true" title="<?php _('Print') ?>" icon="rs rs-print" link="/print-status"></rs-sideicon>
    <rs-sideicon *rsIfPrinting="false" icon="rs rs-move-xy" title="<?php _('Move') ?>" link="/move-tool"></rs-sideicon>
</rs-side><rs-side>
    <rs-sideicon *rsIfConnected="true" icon="rs rs-params" title="<?php _('Status') ?>" link="/params"></rs-sideicon>
</rs-side>
<main>
    <rs-headline *ngIf="printers.active"><i class="fa fa-home"></i> {{printers.printers[printers.active].name}}</rs-headline>
    <rs-headline *ngIf="!(printers.active)"><i class="fa fa-home"></i> <?php _('No Printer Selected') ?></rs-headline>
    <div class="content-h1" rsDrag>
    <div class="margin-leftright" *ngIf="(server$|async).diskUsage?.usage && (server$|async).diskUsage?.available < 1000000000">
      <rs-progress [value]="(server$|async).diskUsage?.usage" [type]="(server$|async).diskUsage?.classname" text="<?php _('Free Disk Space') ?>: {{(server$|async).diskUsage?.available | byte}}"></rs-progress>
    </div>
    <div class="alert error margin-leftright" *ngIf="printer && printer?.recover.state>=2 && printer?.recover.state<=4">
      <?php _('Last print job did not finish. Use the rescue function in the web frontend to continue the aborted job. Starting any new job will void this information and make a rescue impossible!') ?>
    </div>

    <rs-iconlist>
        <rs-icon *ngIf="printers?.active" icon="rs rs-file-gcode" title="<?php _('G-Codes') ?>" link="/gcodes"></rs-icon>
        <rs-icon *ngIf="printers?.active && (printers.printers[printers.active].queue?.length>0)" [counter]="printers.printers[printers.active].queue?.length" icon="rs rs-printqueue" title="<?php _('Print Queue') ?>" link="/print-queue"></rs-icon>
        <rs-icon *rsIfConnected="true" icon="rs rs-move-xy" title="<?php _('Move') ?>" link="/move-tool"></rs-icon>
        <rs-icon *rsIfConnected="true" icon="rs rs-filamentchange" title="<?php _('Change Filament') ?>" link="/changefilament"></rs-icon>
        <rs-icon icon="rs rs-printer" title="<?php _('Printers') ?>" link="/printer-list"></rs-icon>
        <rs-icon *rsIfPrinting="true" icon="rs rs-print" title="<?php _('Print') ?>" link="/print-status"></rs-icon>
        <rs-icon *rsIfConnected="true" icon="rs rs-params" title="<?php _('Status') ?>" link="/params"></rs-icon>
        <rs-icon *ngIf="printers?.active && server.serverFolders?.length" icon="rs rs-usbstick" title="<?php _('Import') ?>" link="/import"></rs-icon>
        <rs-icon *rsIfConnected="true" icon="rs rs-printer-commands" title="<?php _('Console') ?>" link="/console"></rs-icon>
        <rs-icon *ngIf="printer?.config?.quickCommands?.length && printer.online===1" icon="rs rs-printer-commands" title="<?php _('Printer Cmds.') ?>" link="/printer-commands"></rs-icon>
        <rs-icon icon="rs rs-server-commands" title="<?php _('Server Cmds.') ?>" link="/server-commands" *ngIf="(commands$ | async).length"></rs-icon>
        <rs-icon *rsIfConnected="true" icon="rs rs-chart" title="<?php _('Temp. Graph') ?>" link="/temperatures"></rs-icon>
        <rs-icon *ngIf="!wideScreen" icon="fa fa-envelope" title="<?php _('Messages') ?>" link="/messages" [counter]="(messages$|async).length"></rs-icon>
        <rs-icon *ngIf="printer?.config?.webcams?.length>0" icon="rs rs-webcam" title="<?php _('Webcam') ?>" link="/webcam"></rs-icon>
        <rs-icon icon="fa fa-lock" title="<?php _('Lock Screen') ?>" *ngIf="server.settings['frontSetting'] && server.settings['frontSetting'].unlockPin !== ''" link="/unlock"></rs-icon>
        <rs-icon icon="fa fa-gear" title="<?php _('Settings') ?>" link="/settings"></rs-icon>        
        <rs-icon icon="fa fa-refresh" title="<?php _('Restart UI') ?>" (rsClick)="restart()"></rs-icon>
        <rs-icon *ngIf="shutdown" icon="fa fa-power-off" title="<?php _('Shutdown') ?>" (rsClick)="runCommand(shutdown)"></rs-icon>
    </rs-iconlist>
    </div>
</main>
</rs-page>`
})
export class MyDashboardComponent  extends DashboardComponent {
}
